      *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)
      *_> DLTMOD MODULE(@5/@4)
      *_> CRTRPGMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +
      *_>   DBGVIEW(@9) OPTIMIZE(@8) OPTION(*EVENTF)
      * ---------------------------------------------------------------
      * Module.: TG0001_M01           Project.....:
      * Author.: A. Campin            Date written: 06/06/2008
      * Purpose: Screen One. Get Menu Options.
      * ---------------------------------------------------------------
      * Called by: TG0001
      * ---------------------------------------------------------------
      * Revision history:
      *  Project # Pgmr        Date   Desc
      *
      * End Revision History
      * ---------------------------------------------------------------
      *                  Standards
      *                  Function Keys.
      *
      *  F3  - SAA Exit.
      *  F12 - Previous Screen.
      * ---------------------------------------------------------------
      *                       Indicators
      *
      * @@@ Indicators 1 - 25 for data base I/O.
      *
      * @@@ Indicators 26 - 29 for subfile control.
      *
      * @@@ Indicators 30 - 49 display file I/O control.
      *
      * @@@ Indicators 50 - 79 field error indicators.
      *
      * @@@ Indicators 80 - 94 Condition control.
      *
      * @@@ Indicators 95 - 99 Scratch indicators.
      *
      *      99 - Scratch indicator.
      * ---------------------------------------------------------------
     h nomain
     h Option(*Srcstmt:*Nodebugio)

     fTG0001_D01cf   e             WorkStn InfDS(g_dsFileInformation01)
     f                                     UsrOpn
     f                                     Indds(dsIndicators)
     f                                     Include(RD01_01  :
     f                                             SFMSG_CTL)

      /copy *libl/qsrcf,cb_Std_Con
      /copy *libl/qsrcf,cb_StdType
      /copy *libl/qsrcf,xvmsgf_pr
      /copy *libl/qsrcf,tg0001_lp

     d LoadScreenFields...
     d                 pr

     d ValidInput...
     d                 pr                  Like(StdLgl)

     d g_dsFileInformation01...
     d                 ds                  Qualified
     d    KeyPressed...
     d                       369    369

     d g_dsSystem...
     d                sds           333    Qualified
     d   ModuleName...
     d                         1     10
     d   UserName...
     d                       254    263

      /copy *libl/qsrcf,CB_MAP_IND
     d DisplaySubfileEndOnSubfileMessageQueue...
     d                                     Like(StdLgl)
     d                                     Overlay(GenericIN95)

     d cMainProcedureName...
     d                 c                   'PROCESSSCREEN01'

     d g_ProgramName...
     d                 s                   Like(StdNam)
     d                                     Import

     d g_ScreenOpen    s                   Like(StdLgl)
     d                                     Inz(cFalse)
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * ProcessScreen01
      *   Do processing for Screen 01-Standard Menu Panel.
      *   Input     - None
      *   Out       - None
      *   Returns   - Key pressed to end screen.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p ProcessScreen01...
     p                 b                   Export
     d                 pi                  like(StdChr)

      /copy *libl/qsrcf,CB_KEYP

     d cMaintainTriggerControl...
     d                 c                   Const('1')
     d cMaintainTriggerDetail...
     d                 c                   Const('2')
     d KeyPressed...
     d                 s                   Like(StdChr)
      /Free

       If Not g_ScreenOpen;
         g_ScreenOpen = cTrue;
         Open TG0001_D01;
       EndIf;

       LoadScreenFields();

       MSGF_ClearProgramMessageQueue(cMainProcedureName   :
                                     g_dsSystem.ModuleName:
                                     g_ProgramName        );
       DoU 0 = 1;

         // Display subfile messages.
         DisplaySubfileEndOnSubfileMessageQueue = cTrue;
         SFM_C_PGMQ = '*';
         Write SFMSG_CTL;

         ExFmt RD01_01;

         MSGF_ClearProgramMessageQueue(cMainProcedureName   :
                                       g_dsSystem.ModuleName:
                                       g_ProgramName        );
         Clear ErrorIndicators;

         Select;
           When g_dsFileInformation01.KeyPressed = F3 or
                g_dsFileInformation01.KeyPressed = F12;
              Return g_dsFileInformation01.KeyPressed;
           Other;
             If Not ValidInput();
               Iter;
             EndIf;

             Select;
               When B_OPTION = cMaintainTriggerControl;
                 KeyPressed = ProcessScreen02();
               When B_OPTION = cMaintainTriggerDetail;
                 KeyPressed = ProcessScreen03();
             EndSl;

             If KeyPressed = F3;
               Return KeyPressed;
             EndIf;

             LoadScreenFields();
             Iter;
         EndSl;
       EndDo;

      /End-Free
     p                 e
      *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
      * CloseScreen01
      *   Close out Screen 01.
      *  In     Parms - None.
      *  In/Out Parms - None.
      *  Out    Parms - None.
      *  Return       - None.
      *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     p CloseScreen01...
     p                 b                   Export
     d                 pi
      /Free

       Close TG0001_D01;
       g_ScreenOpen = cFalse;
       Return;

      /End-Free
     p                 e
      *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
      * LoadScreenFields
      *   Load any defaults for screen fields.
      *  In     Parms - None.
      *  In/Out Parms - None.
      *  Out    Parms - None.
      *  Return       - None.
      *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     p LoadScreenFields...
     p                 b
     d                 pi
      /Free

       B_OPTION = *Blanks;

      /End-Free
     p                 e
      *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
      * ValidInput
      *   Validate any input done on screen.
      *  In     Parms - None.
      *  In/Out Parms - None.
      *  Out    Parms - None.
      *  Return       - None.
      *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     p ValidInput...
     p                 b
     d                 pi                  Like(StdLgl)
      /Free

       Return cTrue;

      /End-Free
     p                 e
