      *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)
      *_> DLTMOD MODULE(@5/@4)
      *_> CRTSQLRPGI OBJ(@5/@4) +
      *_>   SRCFILE(@2/@1) SRCMBR(@3) +
      *_>   OBJTYPE(*MODULE) COMMIT(*NONE) OPTION(*EVENTF) +
      *_>   DBGVIEW(*SOURCE) CLOSQLCSR(*ENDMOD) +
      *_>   TOSRCFILE(@2/QSQLTEMP1)
      * ---------------------------------------------------------------
      * Module.: TG0001_M04           Project.....:
      * Author.: A. Campin            Date written: 06/10/2008
      * Purpose: Screen Four. Add/Edit/Display a record to Trigger
      *            Control Detail.
      * ---------------------------------------------------------------
      * Called by: TG0001_M03
      * ---------------------------------------------------------------
      * Revision history:
      *  Project # Pgmr        Date   Desc
      *
      * End Revision History
      * ---------------------------------------------------------------
      *                  Standards
      *                  Function Keys.
      *
      *  F3  - SAA Exit.
      *  F12 - Previous Screen.
      * ---------------------------------------------------------------
      *                       Indicators
      *
      * @@@ Indicators 1 - 25 for data base I/O.
      *
      * @@@ Indicators 26 - 29 for subfile control.
      *
      *      26 - Display subfile control.
      *      27 - Display subfile.
      *      28 - Clear subfile.
      *      29 - SFLEND enabled.
      *
      * @@@ Indicators 30 - 49 display file I/O control.
      *
      * @@@ Indicators 50 - 79 field error indicators.
      *
      * @@@ Indicators 80 - 94 Condition control.
      *
      * @@@ Indicators 95 - 99 Scratch indicators.
      *
      *      95 - Subfile message handler.
      *      99 - Scratch indicator.
      * ---------------------------------------------------------------
     h nomain
     h Option(*Srcstmt:*Nodebugio)

     fTG0001_D01cf   e             Workstn InfDs(g_dsFileInformation01)
     f                                     UsrOpn
     f                                     InDDS(dsIndicators)
     f                                     Include(RD01_04  :
     f                                             SFMSG_CTL)

      /copy *libl/qsrcf,cb_Std_Con
      /copy *libl/qsrcf,cb_StdType
      /copy *libl/qsrcf,xverrh_pr
      /copy *libl/qsrcf,xvmsgf_pr
      /copy *libl/qsrcf,tg0001_lp

     d LoadAddFields...
     d                 pr

     d LoadEditFields...
     d                 pr
     d  PR_InFileName...
     d                                     Like(StdNam)
     d                                     Value
     d  PR_InLibraryName...
     d                                     Like(StdNam)
     d                                     Value

     d ValidInput...
     d                 pr                  Like(StdLgl)
     d   PR_InProcessingMode...
     d                                     Like(StdChr)
     d                                     Value

     d AddRecord...
     d                 pr

     d EditRecord...
     d                 pr
     d   PR_InFileName...
     d                                     Like(StdNam)
     d                                     Value
     d   PR_InLibraryName...
     d                                     Like(StdNam)
     d                                     Value

      /copy *libl/qsrcf,CB_MAP_IND
     d ErrorOnFileName...
     d                                     Like(StdLgl)
     d                                     OverLay(GenericIN50)
     d ErrorOnLibraryName...
     d                                     Like(StdLgl)
     d                                     OverLay(GenericIN51)
     d ErrorOnServiceProgramName...
     d                                     Like(StdLgl)
     d                                     OverLay(GenericIN52)
     d ErrorOnServiceLibraryName...
     d                                     Like(StdLgl)
     d                                     OverLay(GenericIN53)
     d ErrorOnServiceProcedure...
     d                                     Like(StdLgl)
     d                                     OverLay(GenericIN54)
     d AddRecordMode...
     d                                     Like(StdLgl)
     d                                     Overlay(GenericIN81)
     d EditRecordMode...
     d                                     Like(StdLgl)
     d                                     overlay(GenericIN82)
     d DisplayRecordMode...
     d                                     Like(StdLgl)
     d                                     Overlay(GenericIN83)
     d DisplaySubfileEndOnSubfileMessageQueue...
     d                                     Like(StdLgl)
     d                                     OverLay(GenericIN95)

     d g_dsFileInformation01...
     d                 ds                  Qualified
     d   KeyPressed...
     d                       369    369

     d g_dsSystem...
     d                sds           333    Qualified
     d   ModuleName...
     d                         1     10
     d   UserName...
     d                       254    263

      /copy *libl/qsrcf,cb_keyp

     d cMainProcedureName...
     d                 c                   Const('PROCESSSCREEN04')
     d cAddRecordMode...
     d                 c                   Const('A')
     d cEditRecordMode...
     d                 c                   Const('E')
     d cDisplayRecordMode...
     d                 c                   Const('D')

     d g_ProgramName...
     d                 s                   Like(StdNam)
     d                                     Import

     d g_ScreenOpen...
     d                 s                   Like(StdLgl)
     d                                     Inz(cFalse)
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * ProcessScreen04
      *  Do processing for Screen 4 - Standard Add/Edit/Display Panel.
      *   Input     - File Name to Edit/Display.
      *               Processing Mode.
      *   Out       - None.
      *   Returns   - Key Pressed to end screen.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p ProcessScreen04...
     p                 b                   Export
     d                 pi                  Like(StdChr)
     d   InFileName...
     d                                     Like(StdNam)
     d                                     Value
     d   InLibraryName...
     d                                     Like(StdNam)
     d                                     Value
     d   InProcessingMode...
     d                                     Like(StdChr)
     d                                     Value
      /Free

       If Not g_ScreenOpen;
         g_ScreenOpen = cTrue;
         Open TG0001_D01;
       EndIf;

       Select;
         When InProcessingMode = cAddRecordMode;
           LoadAddFields();
         When InProcessingMode = cEditRecordMode Or
              InProcessingMode = cDisplayRecordMode;
           LoadEditFields(InFileName   :
                          InLibraryName);
       EndSl;

       MSGF_ClearProgramMessageQueue(cMainProcedureName   :
                                     g_dsSystem.ModuleName:
                                     g_ProgramName        );

       DoU 0 = 1;

         Select;
           When InProcessingMode = cAddRecordMode;
             AddRecordMode = cTrue;
           When InProcessingMode = cEditRecordMode;
             EditRecordMode = cTrue;
           When InProcessingMode = cDisplayRecordMode;
             DisplayRecordMode = cTrue;
         EndSl;

         // Display subfile messages.
         DisplaySubfileEndOnSubfileMessageQueue = cTrue;
         SFM_C_PGMQ = '*';
         Write SFMSG_CTL;

         ExFmt RD01_04;

         MSGF_ClearProgramMessageQueue(cMainProcedureName   :
                                       g_dsSystem.ModuleName:
                                       g_ProgramName        );

         Clear ErrorIndicators;

         AddRecordMode     = cFalse;
         EditRecordMode    = cFalse;
         DisplayRecordMode = cFalse;

         // Process based on key pressed.
         Select;
           When g_dsFileInformation01.KeyPressed = F3 or
                g_dsFileInformation01.KeyPressed = F12;
             Return g_dsFileInformation01.KeyPressed;
           Other;

           If InProcessingMode = cDisplayRecordMode;
             Return g_dsFileInformation01.KeyPressed;
           EndIf;

           If Not ValidInput(InProcessingMode);
             Iter;
           EndIf;

           // If no errors, update database.
           Select;
             When InProcessingMode = cAddRecordMode;
               AddRecord();
             When InProcessingMode = cEditRecordMode;
               EditRecord(InFileName:InLibraryName);
           EndSl;

           // If edit mode, return to caller.
           If InProcessingMode = cEditRecordMode;
             Return Enter;
           EndIf;

           // If Add mode, clear fields and get another record for add.
           LoadAddFields();
           Iter;
         EndSl;
       EndDo;
 001
      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * CloseScreen04
      *   Input     - None
      *   Out       - None
      *   Returns   - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p CloseScreen04...
     p                 b                   Export
     d                 pi
      /Free

       Close TG0001_D01;
       g_ScreenOpen = cFalse;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * LoadAddFields
      *  Load add screen fields.
      *   Input     - None.
      *   Out       - None.
      *   Returns   - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p LoadAddFields...
     p                 b
     d                 pi
      /Free

       B_FILENAME = *Blanks;
       B_LIBNAME  = *Blanks;
       B_ACTIVE   = cYes;
       B_SRVPGM   = *Blanks;
       B_SRVLIB   = *Blanks;
       B_SRVPROC  = *Blanks;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * LoadEditFields
      *  Load edit screen fields.
      *   Input     - None.
      *   Out       - None.
      *   Returns   - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p LoadEditFields...
     p                 b
     d                 pi
     d  InFileName...
     d                                     Like(StdNam)
     d                                     Value
     d  InLibraryName...
     d                                     Like(StdNam)
     d                                     Value

     d dsRecordIn...
     d               e ds                  ExtName(TGCTRLD)
     d                                     Qualified
      /Free

       Exec Sql Select TDFILENAME,
                       TDLIBNAME,
                       TDACTIVE,
                       TDSRVPGM,
                       TDSRVLIB,
                       TDSRVPROC,
                       TDCRTSTAMP,
                       TDCRTUSER,
                       TDEDTSTAMP,
                       TDEDTUSER
                  Into :dsRecordIn
                  From TGCTRLD
                  Where TDFILENAME = :InFileName And
                        TDLIBNAME  = :InLibraryName;
       Select;
         When SqlState = cSqlStateNoRow;
           B_FILENAME = *All'?';
           B_LIBNAME  = *All'?';
           B_ACTIVE   = cNo;
           B_SRVPGM   = *All'?';
           B_SRVLIB   = *All'?';
           B_SRVPROC  = *All'?';
           O_CRTDATE  = *All'?';
           O_CRTTIME  = *All'?';
           O_CRTUSER  = *All'?';
           O_EDTDATE  = *All'?';
           O_EDTTIME  = *All'?';
           O_EDTUSER  = *All'?';
         When SqlState <> cSqlStateOk;
           ERRH_Throw('CPF9898'                                      :
                      cCPFMessageFileName                            :
                      'Fetch From C1 Failed! Sql State = ' + SQLSTATE);
         Other;
           B_FILENAME = dsRecordIn.TDFILENAME;
           B_LIBNAME  = dsRecordIn.TDLIBNAME;
           B_ACTIVE   = dsRecordIn.TDACTIVE;
           B_SRVPGM   = dsRecordIn.TDSRVPGM;
           B_SRVLIB   = dsRecordIn.TDSRVLIB;
           B_SRVPROC  = dsRecordIn.TDSRVPROC;
           O_CRTDATE  = %Char(%Date(dsRecordIn.TDCRTSTAMP):*USA/);
           O_CRTTIME  = %Char(%Time(dsRecordIn.TDCRTSTAMP):*HMS:);
           O_CRTUSER  = dsRecordIn.TDCRTUSER;
           O_EDTDATE  = %Char(%Date(dsRecordIn.TDEDTSTAMP):*USA/);
           O_EDTTIME  = %Char(%Time(dsRecordIn.TDEDTSTAMP):*HMS:);
           O_EDTUSER  = dsRecordIn.TDEDTUSER;
       EndSl;

       Return;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * ValidInput
      *  Validate input.
      *   Input     - None.
      *   Out       - None.
      *   Returns   - True if ok. False if no ok.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p ValidInput...
     p                 b
     d                 pi                  Like(StdLgl)
     d   InProcessingMode...
     d                                     Like(StdChr)
     d                                     Value

     d MsgUGP0001...
     d                 ds                  Qualified
     d   FieldName...
     d                              100    Varying

     d IsValid...
     d                 s                   Like(StdLgl)
     d                                     Inz(cTrue)
     d Count...
     d                 s                   Like(StdInt)
      /Free

       If B_FILENAME = *Blanks or
          B_FILENAME = *All'?';
         IsValid = cFalse;
         ErrorOnFileName = cTrue;
         MsgUGP0001.FieldName = 'File Name';
         MSGF_SendProgramMessage('UGP0001'            :
                                 cXVMessageFileName   :
                                 MsgUGP0001           :
                                 cMainProcedureName   :
                                 g_dsSystem.ModuleName:
                                 g_ProgramName        );
       EndIf;

       If B_LIBNAME = *Blanks or
          B_LIBNAME = *All'?';
          IsValid = cFalse;
         ErrorOnLibraryName = cTrue;
         MsgUGP0001.FieldName = 'Library Name';
         MSGF_SendProgramMessage('UGP0001'            :
                                 cXVMessageFileName   :
                                 MsgUGP0001           :
                                 cMainProcedureName   :
                                 g_dsSystem.ModuleName:
                                 g_ProgramName        );
       EndIf;

       If B_SRVPGM = *Blanks or
          B_SRVPGM = *All'?';
         IsValid = cFalse;
         ErrorOnServiceProgramName = cTrue;
         MsgUGP0001.FieldName = 'Service Program Name';
         MSGF_SendProgramMessage('UGP0001'            :
                                 cXVMessageFileName   :
                                 MsgUGP0001           :
                                 cMainProcedureName   :
                                 g_dsSystem.ModuleName:
                                 g_ProgramName        );
       EndIf;

       If B_SRVLIB = *Blanks;
         IsValid = cFalse;
         ErrorOnServiceLibraryName = cTrue;
         MsgUGP0001.FieldName = 'Service Program Library';
         MSGF_SendProgramMessage('UGP0001'            :
                                 cXVMessageFileName   :
                                 MsgUGP0001           :
                                 cMainProcedureName   :
                                 g_dsSystem.ModuleName:
                                 g_ProgramName        );
       EndIf;

       If B_SRVPROC = *Blanks or
          B_SRVPROC = *All'?';
         IsValid = cFalse;
         ErrorOnServiceProcedure = cTrue;
         MsgUGP0001.FieldName = 'Service Procedure Name';
         MSGF_SendProgramMessage('UGP0001'            :
                                 cXVMessageFileName   :
                                 MsgUGP0001           :
                                 cMainProcedureName   :
                                 g_dsSystem.ModuleName:
                                 g_ProgramName        );
       EndIf;

       If InProcessingMode = cAddRecordMode;
         Exec Sql Select Count(*)
                    Into :Count
                    From TGCTRLD
                    Where TDFILENAME = :B_FILENAME And
                          TDLIBNAME  = :B_LIBNAME;
         Select;
           When SqlState = cSqlStateNoRow;
             Count = 0;
           When SqlState <> cSqlStateOk;
             ERRH_Throw('CPF9898':
                        cCPFMessageFileName:
                        'Error on Select Into Count! Sql State = ' + SqlState);
         EndSl;

         If Count >= 1;
           IsValid = cFalse;
           ErrorOnFileName    = cTrue;
           ErrorOnLibraryName = cTrue;
           MSGF_SendProgramMessage('UTG0003'             :
                                   cXVMessageFileName    :
                                   B_FILENAME + B_LIBNAME:
                                   cMainProcedureName    :
                                   g_dsSystem.ModuleName :
                                   g_ProgramName         );
         EndIf;
       EndIf;

       Return IsValid;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * AddRecord
      *  Add Record to Database.
      *   Input     - None.
      *   Out       - None.
      *   Returns   - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p AddRecord...
     p                 b
     d                 pi

     d dsRecordOutFull...
     d               e ds                  ExtName(TGCTRLD)
     d                                     Qualified
      /Free

       dsRecordOutFull.TDFILENAME = B_FILENAME;
       dsRecordOutFull.TDLIBNAME  = B_LIBNAME;
       dsRecordOutFull.TDACTIVE   = B_ACTIVE;
       dsRecordOutFull.TDSRVPGM   = B_SRVPGM;
       dsRecordOutFull.TDSRVLIB   = B_SRVLIB;
       dsRecordOutFull.TDSRVPROC  = B_SRVPROC;

       dsRecordOutFull.TDCRTSTAMP = %TimeStamp();
       dsRecordOutFull.TDCRTUSER  = g_dsSystem.UserName;
       dsRecordOutFull.TDEDTSTAMP = %TimeStamp();
       dsRecordOutFull.TDEDTUSER  = g_dsSystem.UserName;

       Exec Sql Insert Into TGCTRLD
                  Values(:dsRecordOutFull);

       Return;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * EditRecord
      *  Update Edit record to database.
      *   Input     - None.
      *   Out       - None.
      *   Returns   - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p EditRecord...
     p                 b
     d                 pi
     d  InFileName...
     d                                     Like(StdNam)
     d                                     Value
     d  InLibraryName...
     d                                     Like(StdNam)
     d                                     Value
      /Free

       Exec Sql Update TGCTRLD
                  Set TDACTIVE   = :B_ACTIVE,
                      TDSRVPGM   = :B_SRVPGM,
                      TDSRVLIB   = :B_SRVLIB,
                      TDSRVPROC  = :B_SRVPROC,
                      TDEDTSTAMP = Current_TimeStamp,
                      TDEDTUSER  = :g_dsSystem.UserName
                  Where TDFILENAME = :InFileName And
                        TDLIBNAME  = :InLibraryName;

       Return;

      /End-Free
     p                 e
