      *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)
      *_> DLTMOD MODULE(@5/@4)
      *_> CRTSQLRPGI OBJ(@5/@4) +
      *_>   SRCFILE(@2/@1) SRCMBR(@3) +
      *_>   OBJTYPE(*MODULE) COMMIT(*NONE) OPTION(*EVENTF) +
      *_>   DBGVIEW(*SOURCE) CLOSQLCSR(*ENDMOD) +
      *_>   TOSRCFILE(@2/QSQLTEMP1)
      * ---------------------------------------------------------------
      * Module.: TG0001_M05           Project.....:
      * Author.: A. Campin            Date written: 06/10/2008
      * Purpose: Maintain Detail Trigger Control Records. Confirm delete
      *            of Detail Records.
      * ---------------------------------------------------------------
      * Called by: TG0001_M03
      * ---------------------------------------------------------------
      * Revision history:
      *  Project # Pgmr        Date   Desc
      *
      * End Revision History
      * ---------------------------------------------------------------
      *                  Standards
      *                  Function Keys.
      *
      *  F3  - SAA Exit.
      *  F12 - Previous Screen.
      * ---------------------------------------------------------------
      *                       Indicators
      *
      * @@@ Indicators 1 - 25 for data base I/O.
      *
      * @@@ Indicators 26 - 29 for subfile control.
      *
      *      26 - Display subfile control.
      *      27 - Display subfile.
      *      28 - Clear subfile.
      *      29 - SFLEND enabled.
      *
      * @@@ Indicators 30 - 49 display file I/O control.
      *
      * @@@ Indicators 50 - 79 field error indicators.
      *
      * @@@ Indicators 80 - 94 Condition control.
      *
      * @@@ Indicators 95 - 99 Scratch indicators.
      *
      *      98 - Subfile message handler.
      *      99 - Scratch indicator.
      * ---------------------------------------------------------------
     h nomain
     h Option(*Srcstmt:*Nodebugio)

     fTG0001_D01cf   e             Workstn InfDs(g_dsFileInformation01)
     f                                     Sfile(RD01_05S             :
     f                                           g_SubfileRecordNumber)
     f                                     InDDS(dsIndicators)
     f                                     UsrOpn
     f                                     Include(RD01_05S:
     f                                             RD01_05C:
     f                                             RD01_05O:
     f                                             SF_BLANK:
     f                                             SFMSG_CTL)

      /copy *libl/qsrcf,cb_Std_Con
      /copy *libl/qsrcf,cb_StdType
      /copy *libl/qsrcf,xverrh_pr
      /copy *libl/qsrcf,xvmsgf_pr
      /copy *libl/qsrcf,tg0001_lp

     d DeleteRecords...
     d                 pr

      /copy *libl/qsrcf,CB_MAP_IND
     d DisplaySubfileControl...
     d                                     Like(StdLgl)
     d                                     Overlay(GenericIN26)
     d DisplaySubfile...
     d                                     Like(StdLgl)
     d                                     Overlay(GenericIN27)
     d ClearSubfile...
     d                                     Like(StdLgl)
     d                                     Overlay(GenericIN28)
     d DisplaySubfileEnd...
     d                                     Like(StdLgl)
     d                                     Overlay(GenericIN29)
     d DisplaySubfileEndOnSubfileMessageQueue...
     d                                     Like(StdLgl)
     d                                     Overlay(GenericIN95)

      *--------------------------------------------------------------
      * File information data structure for display file one.
     d g_dsFileInformation01...
     d                 ds                  Qualified
     d   KeyPressed...
     d                       369    369

     d g_dsSystem...
     d                sds           333    Qualified
     d
     d   ModuleName...
     d                         1     10
     d   UserName...
     d                       254    263

      /copy *libl/qsrcf,CB_KEYP

     d cMainProcedureName...
     d                 c                   Const('PROCESSSCREEN05')

     d g_ProgramName...
     d                 s                   Like(StdNam)
     d                                     Import

     d g_ScreenOpen...
     d                 s                   Like(StdLgl)
     d                                     Inz(cFalse)
     d g_SubfileRecordNumber...
     d                 s                   Like(StdScnRRN)
     d g_RecordsInSubfile...
     d                 s                   Like(StdIntSml)
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * ClearSubfile05
      *  Clear Subfile in Screen 05.
      *   Input     - None
      *   Out       - None
      *   Returns   - None
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p ClearSubfile05...
     p                 b                   Export
     d                 pi
      /Free

       If Not g_ScreenOpen;
         g_ScreenOpen = cTrue;
         Open TG0001_D01;
       EndIf;

       ClearSubfile     = cTrue;
       Write RD01_05C;
       ClearSubfile     = cFalse;
       g_RecordsInSubfile = 0;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * WriteSubfile05
      *   Write record to confirm delete subfile.
      *   Input     - File Name to delete.
      *   Out       - None.
      *   Returns   - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p WriteSubfile05...
     p                 b                   Export
     d                 pi
     d   InFileName...
     d                                     Like(StdNam)
     d                                     Value
     d   InLibraryName...
     d                                     Like(StdNam)
     d                                     Value

     d dsRecordIn...
     d                 ds                  Qualified
     d  Active...
     d                                     Like(StdChr)
     d  ServiceProgram...
     d                                     Like(StdNam)
     d  ServiceProgramLibrary...
     d                                     Like(StdNam)
     d  ServiceProcedure...
     d                               50a
      /Free

       Exec Sql Select TDACTIVE,
                       TDSRVPGM,
                       TDSRVLIB,
                       TDSRVPROC
                  Into :dsRecordIn
                  From TGCTRLD
                  Where TDFILENAME = :InFileName And
                        TDLIBNAME  = :InLibraryName;
       Select;
         When SqlState = cSqlStateNoRow;
           Return;
         When SqlState <> cSqlStateOk;
           ERRH_Throw('CPF9898':
                      cCPFMessageFileName:
                      'Fetch Count failed! Sql State = ' + SqlState);
       EndSl;


       g_RecordsInSubfile += 1;
       g_SubfileRecordNumber = g_RecordsInSubfile;

       O_FILENAME = InFileName;
       O_LIBNAME  = InLibraryName;
       O_ACTIVE   = dsRecordIn.Active;
       O_SRVPGM   = dsRecordIn.ServiceProgram;
       O_SRVLIB   = dsREcordIn.ServiceProgramLibrary;
       O_SRVPROC  = %Subst(dsRecordIn.ServiceProcedure:
                           1                          :
                           %Size(O_SRVPROC)           );

       Write RD01_05S;

       Return;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * ProcessScreen05
      *  Do processing for Screen05-Standard Delete Confirmation Panel.
      *   Input     - None
      *   Out       - None
      *   Returns   - Key Pressed to End.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p ProcessScreen05...
     p                 b                   Export
     d                 pi                  like(StdChr)
      /Free

       // If nothing to display, just return.
       If g_RecordsInSubfile <= 0;
         Return ' ';
       EndIf;

       MSGF_ClearProgramMessageQueue(cMainProcedureName   :
                                     g_dsSystem.ModuleName:
                                     g_ProgramName        );
       DoU 0 = 1;

         // Display subfile messages.
         DisplaySubfileEndOnSubfileMessageQueue = cTrue;
         SFM_C_PGMQ = '*';
         Write SFMSG_CTL;

         If g_RecordsInSubfile > 0;
           DisplaySubfile = cTrue;
         Else;
           DisplaySubfile = cFalse;
           Write SF_BLANK;
         EndIf;

         DisplaySubFileControl = cTrue;
         DisplaySubfileEnd     = cTrue;

         Write RD01_05O;
         ExFmt RD01_05C;

         MSGF_ClearProgramMessageQueue(cMainProcedureName   :
                                       g_dsSystem.ModuleName:
                                       g_ProgramName        );
         Clear ErrorIndicators;

         DisplaySubfile        = cFalse;
         DisplaySubfileControl = cFalse;

         Select;
           When g_dsFileInformation01.KeyPressed = F3 or
                g_dsFileInformation01.KeyPressed = F12;
              Return g_dsFileInformation01.KeyPressed;
           Other;
             DeleteRecords();
             Return Enter;
         EndSl;
       EndDo;

       Return *Blank;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * CloseScreen05
      *   Input     - None
      *   Out       - None
      *   Returns   - None
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p CloseScreen05...
     p                 b                   Export
     d                 pi
      /Free

       Close TG0001_D01;
       g_ScreenOpen = cFalse;

       Return;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * DeleteRecords
      *  Delete records from database.
      *   Input     - None
      *   Out       - None
      *   Returns   - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p DeleteRecords...
     p                 b
     d                 pi
      /Free

       For g_SubfileRecordNumber = 1 to g_RecordsInSubfile;
         Chain g_SubfileRecordNumber RD01_05S;
         Exec Sql Delete From TGCTRLD
                    Where TDFILENAME = :O_FILENAME And
                          TDLIBNAME  = :O_LIBNAME;
         If SqlState <> cSqlStateOk;
           ERRH_Throw('CPF9898'                                           :
                      cCPFMessageFileName                                 :
                      'Delete From Detail Failed! Sql State = ' + SqlState);
         EndIf;
       EndFor;

       Return;

      /End-Free
     p                 e
