      *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)
      *_> DLTMOD MODULE(@5/@4)
      *_> CRTSQLRPGI OBJ(@5/@4) +
      *_>   SRCFILE(@2/@1) SRCMBR(@3) +
      *_>   OBJTYPE(*MODULE) CLOSQLCSR(*ENDMOD) +
      *_>   DBGVIEW(*SOURCE) OPTION(*EVENTF)
      * ---------------------------------------------------------------
      * Module.: TG_MED_M03           Project.....:
      * Author.: A. Campin            Date written: 06/04/2008
      * Purpose: This module just load the detail records using an SQL call.
      *            Implemented as separate module so that SQL gets closed after
      *            load.
      * ---------------------------------------------------------------
      * Called by: OS/400 Data Base.
      * ---------------------------------------------------------------
      * Revision history:
      *  Project # Pgmr        Date   Desc
      *
      * End Revision History
      * ---------------------------------------------------------------
     h NoMain
     h Option(*Srcstmt:*Nodebugio)

      /copy *libl/qsrcf,cb_StdType
      /copy *libl/qsrcf,cb_Std_Con

      /copy *libl/qsrcf,tg_Med_pr

      /copy *libl/qsrcf,xverrh_pr
      /copy *libl/qsrcf,xvuspc_pr

     d g_PtrBaseOfDetailRecords...
     d                 s                   Like(StdPtr)
     d                                     Export
     d                                     Inz(*Null)
     d g_NumberOfDetailRecordsLoaded...
     d                 s                   Like(StdInt)
     d                                     Export
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * LoadDetailRecords
      *   Load the detail records into the data structure.
      *     A count of records loaded and a pointer to user space with the
      *       records is loaded into global storage so that they are preserved
      *       between calls.
      *   Input       - None
      *   Out         - None
      *   Returns     - None
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p LoadDetailRecords...
     p                 b                   Export

     d cDetailUserSpaceName...
     d                 c                   Const('TGDTLUSRSP')
     d cDetailUserSpaceLibrary...
     d                 c                   Const('QTEMP')
     d cDetailUserSpaceText...
     d                 c                   Const('Trigger File Detail')

      *- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * Structure of Detail Record available for triggers.
     d dsDetailRecord...
     d                 ds                  LikeDs(TD_DetailRecord)
     d                                     Based(ptrDetailRecord)

     d dsRecordIn...
     d                 ds                  Qualified
     d  FileName...
     d                                     Like(StdNam)
     d  LibraryName...
     d                                     Like(StdNam)
     d  ServiceProgram...
     d                                     Like(StdNam)
     d  ServiceLibrary...
     d                                     Like(StdNam)
     d  ServiceProcedure...
     d                               50a

     d Count...
     d                 s                   Like(StdInt)
      /Free

       g_NumberOfDetailRecordsLoaded = 0;

       // Get a count of records in TGCTRLD with Active = 'Y'.
       Exec SQL Select Count(*)
                  Into :Count
                  From TGCTRLD
                  Where TDACTIVE = 'Y';
       If SqlState <> cSqlStateOk;
         ERRH_Throw('CPF9898'                                     :
                    cCPFMessageFileName                           :
                    'Getting count of records from TGCTRLD failed. +
                       Sql State = ' + SqlState                   );
       EndIf;

       If Count <= 0;
         Return;
       EndIf;

       Monitor;
         USPC_DeleteUserSpace(cDetailUserSpaceName   :
                              cDetailUserSpaceLibrary);
       On-Error;
       EndMon;

       USPC_CreateUserSpace(cDetailUserSpaceName         :
                            cDetailUserSpaceLibrary      :
                            %Size(dsDetailRecord) * Count: // Initial Size
                            cTrue                        : // Make extendable
                            cDetailUserSpaceText         :
                            '*ALL'                       : // Create authority
                            '*YES'                       ); // Replace object

       g_PtrBaseOfDetailRecords =
            USPC_GetPointerToUserSpace(cDetailUserSpaceName   :
                                       cDetailUserSpaceLibrary);

       Exec SQL Declare TDCursor Cursor For
                  Select TDFILENAME,
                         TDLIBNAME,
                         TDSRVPGM,
                         TDSRVLIB,
                         TDSRVPROC
                    From TGCTRLD
                    Where TDACTIVE = 'Y'
                    Order By TDFILENAME,
                             TDLIBNAME
                For Fetch Only;

       Exec SQL Open TDCursor;
       If SqlState <> cSqlStateOk;
         ERRH_Throw('CPF9898'               :
                    cCPFMessageFileName     :
                    'Open of TGCTRLD failed. Sql State = ' + SqlState);
       EndIf;

       Count = 0;
       DoU 0 = 1;
         Exec SQL Fetch Next
                    From TDCursor
                    Into :dsRecordIn;
         Select;
           When SqlState = cSqlStateNoRow;
             Leave;
           When SqlState <> cSqlStateOk;
             ERRH_Throw('CPF9898'               :
                        cCPFMessageFileName     :
                        'Fetch from TGCTRLD failed. Sql State = ' + SqlState);
         EndSl;

         Count += 1;
         ptrDetailRecord = g_PtrBaseOfDetailRecords +
                            ((Count - 1) * %Size(dsDetailRecord));
         dsDetailRecord.FileName              = dsRecordIn.FileName;
         dsDetailRecord.LibraryName           = dsRecordIn.LibraryName;
         dsDetailRecord.ServiceProgramName    = dsRecordIn.ServiceProgram;
         dsDetailRecord.ServiceProgramLibrary = dsRecordIn.ServiceLibrary;
         dsDetailRecord.ServiceProcedure      = dsRecordIn.ServiceProcedure;
         dsDetailRecord.pptrTriggerProcedure  = *Null;
       EndDo;

       Exec SQL Close TDCursor;

       g_NumberOfDetailRecordsLoaded = Count;

       Return;

      /End-Free
     p                 e
