      *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)
      *_> DLTMOD MODULE(@5/@4)
      *_> CRTRPGMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +
      *_>   DBGVIEW(@9) OPTIMIZE(@8)
      *=============================================================================================
      * Module.....: XVUSPC_M01
      * By.........: Alan Campin
      * Date.......: 09/06/2006
      * Purpose....: User Space API's. This module contains functions
      *              for creating, deleting, getting pointer to user
      *              space and other functions for user spaces.
      *---------------------------------------------------------------------------------------------
      * Program Modification Section:
      *------------------------------
      * By.........:
      * Date.......:
      * Description:
      *            :
      *
      *=============================================================================================
     h nomain

      /copy *libl/qsrcf,cb_stdtype

      /copy *libl/qsrcf,cb_std_con

      /copy *libl/qsrcf,cb_std_em

      /copy *libl/qsrcf,xverrh_pr

      /copy *libl/qsrcf,xvuspc_pr

     d ChangeUserSpace...
     d                 pr
     d   PR_InUserSpaceName...
     d                                     Like(StdNam)
     d                                     Value
     d   PR_InUserSpaceLibrary...
     d                                     Like(StdNam)
     d                                     Value
     d   PR_InAttributes...
     d                             1024    Varying
     d                                     Value
     * Constants for Change User Space Attibutes.
     d cChangeUserSpaceSizeKey...
     d                 c                   Const(1)
     d cChangeUserSpaceInitialValueKey...
     d                 c                   Const(2)
     d cChangeUserSpaceMakeExtendableKey...
     d                 c                   Const(3)
     d cChangeUserSpaceTransizePageSizeKey...
     d                 c                   Const(4)

     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     * USPC_CreateUserSpace
     *                 Function is responsible for creating a user space
     *                 in given library.
     *  In     Parms - User Space Name.
     *                 User Space Library.
     *                 Initial Size of User Space.
     *                 Make extendable True/False
     *                 Text for User Space.
     *                 Create Authority.
     *                 Replace Existing User Space. *NO/*YES
     *                 Initial Value.
     *                 Extended Attributes.
     *                 Domain to Create In. *DEFAULT/*SYSTEM/*USER.
     *  In/Out Parms - None.
     *  Out    Parms - None.
     *  Return       - None
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     p USPC_CreateUserSpace...
     p                 b                   Export
     d                 pi
     d   InUserSpaceName...
     d                                     Like(StdNam)
     d                                     Value
     d   InUserSpaceLibrary...
     d                                     Like(StdNam)
     d                                     Value
     d   InInitialSize...
     d                                9p 0 Value
     d   InMakeExtendable...
     d                                     Like(StdLgl)
     d                                     Value
     d   InText...
     d                                     Like(StdTxt)
     d                                     Value
     d                                     Options(*NoPass)
     d   InCreateAuthority...
     d                                     Like(StdNam)
     d                                     Value
     d                                     Options(*NoPass)
     d   InReplace...
     d                                     Like(StdNam)
     d                                     Value
     d                                     Options(*NoPass)
     d   InPagesToTransfer...
     d                                     Like(StdIntSml)
     d                                     Value
     d                                     Options(*NoPass)
     d   InOptimizeSpaceAlignment...
     d                                     Like(StdChr)
     d                                     Value
     d                                     Options(*NoPass)
     d   InInitialValue...
     d                                     Like(StdChr)
     d                                     Value
     d                                     Options(*NoPass)
     d   InExtendedAttributes...
     d                                     Like(StdNam)
     d                                     Value
     d                                     Options(*NoPass)
     d   InDomain...
     d                                     Like(StdNam)
     d                                     Value
     d                                     Options(*NoPass)

     d CrtUsrSpcAPI    PR                  ExtPgm('QUSCRTUS')
     d   PR_QualifiedUserSpace...
     d                                     Like(StdQNam)
     d   PR_ExtendAttributes...
     d                                     Like(StdNam)
     d   PR_InitialSize...
     d                                     Like(StdInt)
     d   PR_InitialValue...
     d                                     Like(StdChr)
     d   PR_CreateAuthority...
     d                                     Like(StdNam)
     d   PR_Text...
     d                                     Like(StdTxt)
     d   PR_ReplaceExistingUserSpace...
     d                                     Like(StdNam)
     d   PR_APIError...
     d                                     Like(Td_StdErrorModel)
     d   PR_Domain...
     d                                     Like(StdNam)
     d   PR_PagesToTransfer...
     d                                     Like(StdInt)
     d   PR_OptimizeSpaceAlignment...
     d                                     Like(StdChr)
     *- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     *  -  Variable declarations                                    -
     d US_QualUsrSpc   s                   Like(StdQNam)
     d US_InitSize     s                   Like(StdInt)
     d US_Text         s                   Like(StdTxt)
     d US_ExtAttr      s                   Like(StdNam)
     d US_InitVal      s                   Like(StdChr)
     d                                     Inz(X'00')
     d US_Authority    s                   Like(StdNam)
     d                                     Inz('*CHANGE')
     d US_Replace      s                   Like(StdNam)
     d                                     Inz('*NO')
     d US_Domain       s                   Like(StdNam)
     d                                     Inz('*DEFAULT')
     d US_TransferPages...
     d                 s                   Like(StdInt)
     d                                     Inz(0)
     d US_OptimizeAlignment...
     d                 s                   Like(StdChr)
     d                                     Inz('1')
     d ApiError...
     d                 ds                  LikeDs(TD_StdErrorModel)

     d AttributeChangeRecord...
     d                 ds                  LikeDs(TD_AttributeChangeRecord)

     d MakeExtendableRequest...
     d                 ds                  Qualified
     d   StdAttribute...
     d                                     LikeDs(TD_AttributeChangeRecord)
     d   MakeExtendableFlag...
     d                                     Like(StdChr)
      /Free

       DoU 0 = 1;
         If %Parms < 5;
           Leave;
         EndIf;
         US_Text = InText;
         If %Parms < 6;
           Leave;
         EndIf;
         US_Authority = InCreateAuthority;
         If %Parms < 7;
           Leave;
         EndIf;
         US_Replace = InReplace;
         If %Parms < 8;
           Leave;
         EndIf;
         US_TransferPages = InPagesToTransfer;
         If %Parms < 9;
           Leave;
         EndIf;
         US_OptimizeAlignment = InOptimizeSpaceAlignment;
         If %Parms < 10;
           Leave;
         EndIf;
         US_InitVal = InInitialValue;
         If %Parms < 11;
           Leave;
         EndIf;
         US_ExtAttr = InExtendedAttributes;
         If %Parms < 12;
           Leave;
         EndIf;
         US_Domain = InDomain;
         Leave;
       EndDo;

       US_QualUsrSpc = InUserSpaceName + InUserSpaceLibrary;
       US_InitSize   = InInitialSize;

       ApiError.Size           = %Size(ApiError);
       ApiError.BytesAvailable = 0;
       CrtUsrSpcAPI(US_QualUsrSpc       :
                    US_ExtAttr          :
                    US_InitSize         :
                    US_InitVal          :
                    US_Authority        :
                    US_Text             :
                    US_Replace          :
                    ApiError            :
                    US_Domain           :
                    US_TransferPages    :
                    US_OptimizeAlignment);

       If ApiError.BytesAvailable > 0;
         ERRH_Throw(ApiError.MessageId  :
                    cCPFMessageFileName:
                    ApiError.MessageData);
       EndIf;

       If InMakeExtendable;
         MakeExtendableRequest.StdAttribute.NumberOfAttributesBeingPassed = 1;
         MakeExtendableRequest.StdAttribute.AttributeKey =
                        cChangeUserSpaceMakeExtendableKey;
         MakeExtendableRequest.StdAttribute.SizeOfAttributeData =
                        %Size(MakeExtendableRequest.MakeExtendableFlag);
         MakeExtendableRequest.MakeExtendableFlag = '1'; //'1 makes extendable

         Monitor;
           ChangeUserSpace(InUserSpaceName      :
                           InUserSpaceLibrary   :
                           MakeExtendableRequest);
         On-Error;
           ERRH_Rethrow();
         EndMon;
       EndIf;

       Return;

      /End-Free
     p                 e
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     * USPC_DeleteUserSpace
     *   Function is responsible for deleting a user space in a given
     *     library.
     *  In     Parms - User Space Name.
     *                 User Space Library.
     *  In/Out Parms - None.
     *  Out    Parms - None.
     *  Return       - None.
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     p USPC_DeleteUserSpace...
     p                 b                   Export
     d                 pi
     d   InUserSpaceName...
     d                                     Like(StdNam)
     d                                     Value
     d   InUserSpaceLibrary...
     d                                     Like(StdNam)
     d                                     Value

     d DltUsrSpcAPI    PR                  ExtPgm('QUSDLTUS')
     d   PR_QualifiedUserSpaceName...
     d                                     Like(StdQNam)
     d   PR_APIError...
     d                                     LikeDs(TD_StdErrorModel)

     d US_QualUsrSpc   s                   Like(StdQNam)
     d ApiError...
     d                 ds                  LikeDs(TD_StdErrorModel)
      /Free

       US_QualUsrSpc = InUserSpaceName + InUserSpaceLibrary;

       ApiError.Size           = %Size(ApiError);
       ApiError.BytesAvailable = 0;
       DltUsrSpcAPI(US_QualUsrSpc:
                    ApiError     );

       If ApiError.BytesAvailable > 0;
         ERRH_Throw(ApiError.MessageId:
                    cCPFMessageFileName:
                    ApiError.MessageData);
       EndIf;

      /End-Free
     p                 e
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     * USPC_GetPointerToUserSpace
     *   Function is responsible for getting a pointer to a given user
     *     space.
     *  In     Parms - User Space Name.
     *                 User Space Library.
     *  In/Out Parms - None.
     *  Out    Parms - None.
     *  Return       - Pointer to User Space.
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     p USPC_GetPointerToUserSpace...
     p                 b                   Export
     d                 pi                  Like(StdPtr)
     d   InUserSpaceName...
     d                                     Like(StdNam)
     d                                     Value
     d   InUserSpaceLibrary...
     d                                     Like(StdNam)
     d                                     Value

     d GetPtrToUspAPI  pr                  Extpgm('QUSPTRUS')
     d   PR_QualifiedUserSpaceName...
     d                                     Like(StdQNam)
     d   PR_PointerToUserSpace...
     d                                     Like(StdPtr)
     d   PR_APIError...
     d                                     LikeDs(TD_StdErrorModel)

     d US_QualUsrSpc   s                   Like(StdQNam)
     d US_PtrToUsrSp   s                   Like(StdPtr)
     d ApiError...
     d                 ds                  LikeDs(TD_StdErrorModel)
      /Free

       US_QualUsrSpc = InUserSpaceName + InUserSpaceLibrary;

       ApiError.Size           = %Size(ApiError);
       ApiError.BytesAvailable = 0;
       GetPtrToUspAPI(US_QualUsrSpc:
                      US_PtrToUsrSp:
                      ApiError     );

       If ApiError.BytesAvailable > 0;
         ERRH_Throw(ApiError.MessageId   :
                    cCPFMessageFileName  :
                    ApiError.MessageData);
       EndIf;

       Return US_PtrToUsrSp;

      /End-Free
     p                 e
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     * USPC_ChangeUserSpaceSize
     *    Function is responsible for changing the size of a given user
     *      space (Plus or Minus).
     *  In     Parms  - User Space Name.
     *                  User Space Library.
     *                  New User Space Size.
     *  In/Out Parms  - None.
     *  Out    Parms  - None.
     *  Return        - None.
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     p USPC_ChangeUserSpaceSize...
     p                 b                   Export
     d                 pi
     d   InUserSpaceName...
     d                                     Like(StdNam)
     d                                     Value
     d   InUserSpaceLibrary...
     d                                     Like(StdNam)
     d                                     Value
     d   InNewSize...
     d                                9p 0 Value

     d AttributeChangeRecord...
     d                 ds                  LikeDs(TD_AttributeChangeRecord)

     d ChangeSizeRequest...
     d                 ds                  Qualified
     d   StdAttribute...
     d                                     LikeDs(TD_AttributeChangeRecord)
     d   NewSize                           Like(StdInt)
      /Free

       ChangeSizeRequest.StdAttribute.NumberOfAttributesBeingPassed = 1;
       ChangeSizeRequest.StdAttribute.AttributeKey =
                                         cChangeUserSpaceSizeKey;
       ChangeSizeRequest.StdAttribute.SizeOfAttributeData =
                                         %Size(ChangeSizeRequest.NewSize);
       ChangeSizeRequest.NewSize = InNewSize;

       Monitor;
         ChangeUserSpace(InUserSpaceName   :
                         InUserSpaceLibrary:
                         ChangeSizeRequest );
       On-Error;
         ERRH_Rethrow();
       EndMon;

       Return;

      /End-Free
     p                 e
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     * ChangeUserSpace
     *   Function is responsible for changing the attributes of a user
     *      user space.
     *  In     Parms  - User Space Name.
     *                  User Space Library.
     *                  Attributes. Data structure contains attributes to
     *                     change.
     *  In/Out Parms  - None.
     *  Out    Parms  - None.
     *  Return        - None.
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     p ChangeUserSpace...
     p                 b                   Export
     d                 pi
     d  InUserSpaceName...
     d                                     Like(StdNam)
     d                                     Value
     d  InUserSpaceLibrary...
     d                                     Like(StdNam)
     d                                     Value
     d  InAttributes...
     d                             1024    Varying
     d                                     Value

     d ChgUsrSpcAtAPI  pr                  ExtPgm('QUSCUSAT')
     d   PR_ReturnLibraryObjectFoundIn...
     d                                     Like(StdNam)
     d   PR_QualifiedUserSpaceName...
     d                                     Like(StdQNam)
     d   PR_AttributeChangeStructure...
     d                            32767    Options(*VarSize)
     d   PR_APIError...
     d                                     LikeDs(TD_StdErrorModel)

     d ReturnLibraryNameObjectFoundIn...
     d                 s                   Like(StdNam)
     d US_QualUsrSpc   s                   Like(StdQNam)
     d WorkAttributes...
     d                 s          32767    Based(PtrAttributes)
     d ApiError...
     d                 ds                  LikeDs(TD_StdErrorModel)
      /Free

       US_QualUsrSpc = InUserSpaceName + InUserSpaceLibrary;

       ApiError.Size           = %Size(ApiError);
       ApiError.BytesAvailable = 0;
       ptrAttributes = %Alloc(%Len(InAttributes));
       %Subst(WorkAttributes:1:%Len(InAttributes)) = InAttributes;
       ChgUsrSpcAtAPI(ReturnLibraryNameObjectFoundIn:
                      US_QualUsrSpc                 :
                      WorkAttributes                :
                      ApiError                      );

       DeAlloc ptrAttributes;

       If ApiError.BytesAvailable > 0;
         ERRH_Throw(ApiError.MessageId :
                    cCPFMessageFileName :
                    ApiError.MessageData);
       EndIf;

       Return;

      /End-Free
     p                 e
